#include "jump.h"
#include <wiringPiSPI.h>
#include <wiringPi.h>
int b_wiringpi_setup_gpio(int nest, int n);
int b_wiringpi_setup_gpio(int nest, int n){
int arg1,varX,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 1){arg1 = Jderef(Jget_goal(2));
varX = Jmakevar();
if(Junify(arg1,varX) == YES)
{Junify(varX,Jmakeint(wiringPiSetupGpio()));return(Jresolve_all(Jget_trail_end(),Jget_sp(),nest+1));}}return(NO);}
int b_wiringpi_spi_setup_ch_speed(int nest, int n);
int b_wiringpi_spi_setup_ch_speed(int nest, int n){
int arg1,arg2,arg3,varX,varY,varZ,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 3){arg1 = Jderef(Jget_goal(2));
arg2 = Jderef(Jget_goal(3));
arg3 = Jderef(Jget_goal(4));
varX = Jmakevar();
varY = Jmakevar();
varZ = Jmakevar();
if(Junify(arg1,varX) == YES && 
Junify(arg2,varY) == YES && 
Junify(arg3,varZ) == YES)
{Junify(varZ,Fmakeint(wiringPiSPISetup(Jget_int(Jderef(varX)),Jget_int(Jderef(varY)))));return(Jresolve_all(Jget_trail_end(),Jget_sp(),nest+1));}}return(NO);}
int b_pwm_set_mode(int nest, int n);
int b_pwm_set_mode(int nest, int n){
int arg1,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 1){arg1 = Jderef(Jget_goal(2));
if(Junify(arg1,Jmakesym("pwm_mode_ms")) == YES)
{pwmSetMode(PWM_MODE_MS);return(Jresolve_all(Jget_trail_end(),Jget_sp(),nest+1));}if(Junify(arg1,Jmakesym("pwm_mode_bal")) == YES)
{pwmSetMode(PWM_MODE_BAL);return(Jresolve_all(Jget_trail_end(),Jget_sp(),nest+1));}}return(NO);}
int b_pwm_set_range(int nest, int n);
int b_pwm_set_range(int nest, int n){
int arg1,varX,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 1){arg1 = Jderef(Jget_goal(2));
varX = Jmakevar();
if(Junify(arg1,varX) == YES)
{body = Jcons(Jmakesym("integer"),Jcons(varX,NIL));
int trail_end;
trail_end = Jget_trail_end();
Jset_length(body);
Jpush_trail_body(body);
if(Jresolve_all(save1,Jget_sp(),nest+1) == YES){
pwmSetRange(Jget_int(Jderef(varX)));
Jset_tp(save1);return(Jresolve_all(trail_end,Jget_sp(),nest+1));}}
Jset_tp(save1);
Jretract_goal(nest);
Junbind(save2);
}return(NO);}
int b_pwm_set_clock(int nest, int n);
int b_pwm_set_clock(int nest, int n){
int arg1,varX,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 1){arg1 = Jderef(Jget_goal(2));
varX = Jmakevar();
if(Junify(arg1,varX) == YES)
{body = Jcons(Jmakesym("integer"),Jcons(varX,NIL));
int trail_end;
trail_end = Jget_trail_end();
Jset_length(body);
Jpush_trail_body(body);
if(Jresolve_all(save1,Jget_sp(),nest+1) == YES){
pwmSetClock(Jget_int(Jderef(varX)));
Jset_tp(save1);return(Jresolve_all(trail_end,Jget_sp(),nest+1));}}
Jset_tp(save1);
Jretract_goal(nest);
Junbind(save2);
}return(NO);}
int b_pin_mode(int nest, int n);
int b_pin_mode(int nest, int n){
int arg1,arg2,varX,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 2){arg1 = Jderef(Jget_goal(2));
arg2 = Jderef(Jget_goal(3));
varX = Jmakevar();
if(Junify(arg1,varX) == YES && 
Junify(arg2,Jmakesym("input")) == YES)
{pinMode(Jget_int(Jderef(varX)), INPUT);return(Jresolve_all(Jget_trail_end(),Jget_sp(),nest+1));}varX = Jmakevar();
if(Junify(arg1,varX) == YES && 
Junify(arg2,Jmakesym("output")) == YES)
{pinMode(Jget_int(Jderef(varX)), OUTPUT);return(Jresolve_all(Jget_trail_end(),Jget_sp(),nest+1));}varX = Jmakevar();
if(Junify(arg1,varX) == YES && 
Junify(arg2,Jmakesym("pwm_output")) == YES)
{pinMode(Jget_int(Jderef(varX)), PWM_OUTPUT);return(Jresolve_all(Jget_trail_end(),Jget_sp(),nest+1));}}return(NO);}
int b_digital_write(int nest, int n);
int b_digital_write(int nest, int n){
int arg1,arg2,varX,varY,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 2){arg1 = Jderef(Jget_goal(2));
arg2 = Jderef(Jget_goal(3));
varX = Jmakevar();
varY = Jmakevar();
if(Junify(arg1,varX) == YES && 
Junify(arg2,varY) == YES)
{body = Jlist3(Jmakesym(","),Jcons(Jmakesym("integer"),Jcons(varX,NIL)),Jcons(Jmakesym("integer"),Jcons(varY,NIL)));
int trail_end;
trail_end = Jget_trail_end();
Jset_length(body);
Jpush_trail_body(body);
if(Jresolve_all(save1,Jget_sp(),nest+1) == YES){
digitalWrite(Jget_int(Jderef(varX)),Jget_int(Jderef(varY)));
Jset_tp(save1);return(Jresolve_all(trail_end,Jget_sp(),nest+1));}}
Jset_tp(save1);
Jretract_goal(nest);
Junbind(save2);
}return(NO);}
int b_digital_write_byte(int nest, int n);
int b_digital_write_byte(int nest, int n){
int arg1,varX,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 1){arg1 = Jderef(Jget_goal(2));
varX = Jmakevar();
if(Junify(arg1,varX) == YES)
{body = Jcons(Jmakesym("integer"),Jcons(varX,NIL));
int trail_end;
trail_end = Jget_trail_end();
Jset_length(body);
Jpush_trail_body(body);
if(Jresolve_all(save1,Jget_sp(),nest+1) == YES){
digitalWriteByte(Jget_int(Jderef(varX)));
Jset_tp(save1);return(Jresolve_all(trail_end,Jget_sp(),nest+1));}}
Jset_tp(save1);
Jretract_goal(nest);
Junbind(save2);
}return(NO);}
int b_pwm_write(int nest, int n);
int b_pwm_write(int nest, int n){
int arg1,arg2,varX,varY,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 2){arg1 = Jderef(Jget_goal(2));
arg2 = Jderef(Jget_goal(3));
varX = Jmakevar();
varY = Jmakevar();
if(Junify(arg1,varX) == YES && 
Junify(arg2,varY) == YES)
{body = Jlist3(Jmakesym(","),Jcons(Jmakesym("integer"),Jcons(varX,NIL)),Jcons(Jmakesym("integer"),Jcons(varY,NIL)));
int trail_end;
trail_end = Jget_trail_end();
Jset_length(body);
Jpush_trail_body(body);
if(Jresolve_all(save1,Jget_sp(),nest+1) == YES){
pwmWrite(Jget_int(Jderef(varX)),Jget_int(Jderef(varY)));
Jset_tp(save1);return(Jresolve_all(trail_end,Jget_sp(),nest+1));}}
Jset_tp(save1);
Jretract_goal(nest);
Junbind(save2);
}return(NO);}
int b_pull_up_dn_control(int nest, int n);
int b_pull_up_dn_control(int nest, int n){
int arg1,arg2,varX,varY,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 2){arg1 = Jderef(Jget_goal(2));
arg2 = Jderef(Jget_goal(3));
varX = Jmakevar();
varY = Jmakevar();
if(Junify(arg1,varX) == YES && 
Junify(arg2,varY) == YES)
{body = Jlist3(Jmakesym(","),Jcons(Jmakesym("integer"),Jcons(varX,NIL)),Jcons(Jmakesym("integer"),Jcons(varY,NIL)));
int trail_end;
trail_end = Jget_trail_end();
Jset_length(body);
Jpush_trail_body(body);
if(Jresolve_all(save1,Jget_sp(),nest+1) == YES){
pullUpDnControl(Jget_int(Jderef(varX)),Jget_int(Jderef(varY)));
Jset_tp(save1);return(Jresolve_all(trail_end,Jget_sp(),nest+1));}}
Jset_tp(save1);
Jretract_goal(nest);
Junbind(save2);
}return(NO);}
int b_digital_read(int nest, int n);
int b_digital_read(int nest, int n){
int arg1,arg2,varX,varY,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 2){arg1 = Jderef(Jget_goal(2));
arg2 = Jderef(Jget_goal(3));
varX = Jmakevar();
varY = Jmakevar();
if(Junify(arg1,varX) == YES && 
Junify(arg2,varY) == YES)
{body = Jcons(Jmakesym("integer"),Jcons(varX,NIL));
int trail_end;
trail_end = Jget_trail_end();
Jset_length(body);
Jpush_trail_body(body);
if(Jresolve_all(save1,Jget_sp(),nest+1) == YES){
Junify(varY,Fmakeint(digitalRead(Jget_int(varX))));
Jset_tp(save1);return(Jresolve_all(trail_end,Jget_sp(),nest+1));}}
Jset_tp(save1);
Jretract_goal(nest);
Junbind(save2);
}return(NO);}
int b_delay(int nest, int n);
int b_delay(int nest, int n){
int arg1,varX,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 1){arg1 = Jderef(Jget_goal(2));
varX = Jmakevar();
if(Junify(arg1,varX) == YES)
{body = Jcons(Jmakesym("integer"),Jcons(varX,NIL));
int trail_end;
trail_end = Jget_trail_end();
Jset_length(body);
Jpush_trail_body(body);
if(Jresolve_all(save1,Jget_sp(),nest+1) == YES){
delay(Jget_int(Jderef(varX)));
Jset_tp(save1);return(Jresolve_all(trail_end,Jget_sp(),nest+1));}}
Jset_tp(save1);
Jretract_goal(nest);
Junbind(save2);
}return(NO);}
int b_delay_microseconds(int nest, int n);
int b_delay_microseconds(int nest, int n){
int arg1,varX,body,save1,save2;
save1 = Jget_tp();
save2 = Jget_sp();
if(n == 1){arg1 = Jderef(Jget_goal(2));
varX = Jmakevar();
if(Junify(arg1,varX) == YES)
{delayMicroseconds(Jget_int(Jderef(varX)));return(Jresolve_all(Jget_trail_end(),Jget_sp(),nest+1));}}return(NO);}
void init_tpredicate(void){(deftpred)("wiringpi_setup_gpio",b_wiringpi_setup_gpio);
(deftpred)("wiringpi_spi_setup_ch_speed",b_wiringpi_spi_setup_ch_speed);
(deftpred)("pwm_set_mode",b_pwm_set_mode);
(deftpred)("pwm_set_range",b_pwm_set_range);
(deftpred)("pwm_set_clock",b_pwm_set_clock);
(deftpred)("pin_mode",b_pin_mode);
(deftpred)("digital_write",b_digital_write);
(deftpred)("digital_write_byte",b_digital_write_byte);
(deftpred)("pwm_write",b_pwm_write);
(deftpred)("pull_up_dn_control",b_pull_up_dn_control);
(deftpred)("digital_read",b_digital_read);
(deftpred)("delay",b_delay);
(deftpred)("delay_microseconds",b_delay_microseconds);
}void init_declare(void){}