%from Prolog programming for articial intelligence.
% All rights reserved by I. Bratko

twice_even_number([],[]).
twice_even_number([N|Ns],[N2|M]) :-
	N1 is N mod 2,
    N1 == 0,
    N2 is 2*N,
    twice_even_number(Ns,M).
twice_even_number([N|Ns],[N|M]) :-
	twice_even_number(Ns,M).


addelt([],E,[E]).
addelt([X|Xs],E,[X|Y]) :- 
	addelt(Xs,E,Y).

%queens problem
solution( [] ).
solution( [X/Y|Others]):-
 solution( Others ),
 member( Y, [1,2,3,4,5,6,7,8] ),
 noattack( X/Y, Others ).

noattack( _,[] ).

noattack( X/Y, [X1/Y1|Others] ):-
 Y =\= Y1,
 Y1-Y =\= X1-X,
 Y1-Y =\= X-X1,
 noattack( X/Y,Others ).

template( [1/Y1,2/Y2,3/Y3,4/Y4,5/Y5,6/Y6,7/Y7,8/Y8] ).

test :- template(S),solution(S),write(S),nl,fail.


maxlist([X],X).
maxlist([X|Xs],X) :-
	maxlist(Xs,Y),
    X > Y.
maxlist([X|Xs],Y) :-
	maxlist(Xs,Y),
    X =< Y.
    
orderd([X,Y]) :-
	X =< Y.
orderd([X1,X2|Xs]) :-
	X1 =< X2,
    orderd([X2|Xs]).

%p79
evenlength([]).
evenlength([_|L]) :- oddlength(L).
oddlength([_]).
oddlength([_|L]) :- evenlength(L).


    
palindrome(L) :-
	reverse(L,L1),
    L = L1.
    
